#ifndef LENDER_H
#define LENDER_H
#include "/home/CS/cs536/002/dgus7193/fltk/include/FL/Fl_Check_Button.H"
#include <stdio.h>
#include <fstream>


class Lender : public Fl_Check_Button {
 public:
  char _name[65];			//Lender Name (64 chars max)
  char _contact[65];			//Lender Contact (64 chars max)
  char _phone[15];			//Lender Phone (64 chars max)
  double _id;				//Lender ID (14 ints max)
  Lender* next;				//Pointer to next Lender in linkedlist
  Lender* prev;				//Pointer to previous Lender in linkedlist


  //******************************Constructor*****************************
  //Constructor for the Lender class. This function takes in the lender name,
  //contact, phone, ID, and previous pointer in the linked list. It then
  //creates the lender as a subclass of FLTK's check button.
  //**********************************************************************
  Lender(char* n, char* c, char* p, double id,Lender* previous):Fl_Check_Button(15,65,380,75," "){
    strcpy( _name, n );
    strcpy( _contact, c );
    strcpy( _phone, p );
    _id = id;
    prev = previous;
    next = NULL;
    char* labelstring = new char[500];
    sprintf(labelstring,"Lender:%s\nContact:%s\nPhone:%s\nID:%.0lf",n,c,p,id);
    label(labelstring);
  }
  

  //**************************Default Constructor*************************
  //Default Constructor for the Lender class. This function creates the
  //lender as a subclass of FLTK's check button, then sets the previous
  //and next pointers for the linked list to NULL.
  //**********************************************************************
  Lender():Fl_Check_Button(15,65,380,50,""){
    next = NULL;
    prev = NULL;
  }


  //***********************writeLenderReport******************************
  //This function writes the lender report file. It takes in the linked
  //list and produces an output file. It then returns (void)
  //**********************************************************************
  void writeLenderReport(Lender* list){
    ofstream fout("lenders_report.txt");
    char output[500];
    while(list!=NULL){
      
      sprintf(output,"ID:%.0lf  Name:%s  Contact:%s  Phone:%s\n",list->_id,list->_name,list->_contact,list->_phone);
      fout << output;
      list=list->next;
    }
    fout.close();
  }
};
#endif




