#ifndef SELECTION_H
#define SELECTION_H
#include "Lender.h"

class Selection {
 public:

  enum {  // case statement enum for dynamic cursor creation
    FM_JUMBO,
    FM_REG,
    FM_JUM_REG,
    ARM_JUMBO,
    ARM_REG,
    ARM_JUM_REG,
    BOTH_JUMBO,
    BOTH_REG,
    ALL
  };
  int sort;				//Integer that uses the above enum
  bool ascending;			//Toggle ascending/descending

  //The following are all the criteria for searching
  bool isFM;
  bool isARM;
  bool isRegular;
  bool isJumbo;
  bool isGood;
  bool isLate;
  bool isDefault;
  bool isBundled;
  bool isUnBundled;
  bool showAll;

  //min,max pairs for searching
  int min_dd, min_mm, min_yyyy;
  int max_dd, max_mm, max_yyyy;
  float amount[2];
  float IR[2];
  int term[2];
  int risk[2];
  double discountRate[2];
  
  //Used for searching for specific IDs
  int Lender;
  int Borrower;


  //*********************Constructor****************************
  //Constructor sets all searching/sorting values to appropriate
  //default values.  Min/Max pairs are set to absolute minimum
  //and maximum values for each variable.
  //************************************************************
  Selection(){
    sort = 0;
    isFM = true;
    isARM = true;
    isRegular = true;
    isJumbo = true;
    isGood = true;
    isLate = true;
    isDefault = false;
    isBundled = false;
    isUnBundled = true;
    showAll = false;
    amount[0] = 0; amount[1] = 10000000;
    discountRate[0]=0; discountRate[1]=10000000;
    IR[0] = 0; IR[1] = 100;
    term[0] = 0; term[1] = 1000;
    risk[0] = 0; risk[1] = 100;
    min_dd = 1; min_mm = 1; min_yyyy = 1800;
    max_dd = 31; max_mm = 12; max_yyyy = 2200;
    Lender = -1;
    Borrower = -1;
    lendID = 421;
    name = "Blah";
    phone = "5555";
    contact = "Jim";
    PR = 0;
    Weight = 0;
  };

  //This stuff is for extra GUI functionality
  double Total;
  int Risk;
  int Term;
  double Profit;
  double PR; //For weighted RISK calculation
  double Weight; //Also for weighted RISK calc

  int lendID;
  char* name;
  char* phone;
  char* contact;
};
#endif
