create or replace procedure lrrollforward IS 

   CURSOR c0 IS select term from loans where  principal_remaining is not null and principal_remaining <> original_amount and status <> 2 and interest_rate_type = 0 AND purchased = 1 AND bundle_id is NULL AND term > 0 FOR UPDATE;
   CURSOR c1 IS select monthly_payment, principal_remaining, interest_rate from loans where principal_remaining is not null and status <> 2 and interest_rate_type = 0 AND purchased = 1 AND bundle_id is NULL AND term > 0 FOR UPDATE;
-- The above query updates the term of all the loans it selects. If a LoanStatus report duplicates the data in the NewLoan report 
---- (by supplying the principle_remaining field) the term will wrongly be decremented. --*** This is an ambiguity in the requirments doc. ***--
   CURSOR c2 IS select id, original_amount, interest_rate from loans where principal_remaining is null and interest_rate_type = 0 AND bundle_id IS NULL FOR UPDATE;
   CURSOR c3 IS select id from jpos4168.borrowers for update; 
   CURSOR c4 (brecid borrowers.id%type) IS  select count(loans.id) as num, status from loans, borrowers_have_loans where loans.id = borrowers_have_loans.loan_id and borrowers_have_loans.borrower_id = brecid AND loans.bundle_id is NULL group by status;
   CURSOR c5 IS select * from loans where interest_rate_type = 0 and purchased = 1 and bundle_id is NULL FOR UPDATE;
   CURSOR c7 IS select * from loans where interest_rate_type = 1 and purchased = 1 and bundle_id is NULL FOR UPDATE;
   CURSOR c8 is select risk, principal_remaining, monthly_payment, term FROM loans WHERE purchased = 1 AND bundle_id IS NULL FOR UPDATE;
   CURSOR c9 is select principal_remaining, discount_rate, monthly_payment, term FROM loans WHERE purchased = 1 AND bundle_id IS NULL FOR UPDATE;
   good_loans 		borrowers.risk%TYPE;
   late_loans  		borrowers.risk%TYPE;
   default_loans 	borrowers.risk%TYPE;
   calc_risk		borrowers.risk%TYPE;
   num_temp 		borrowers.risk%TYPE;
   n_risk		loans.risk%TYPE;
   years_left		number(2);
   pr			loans.principal_remaining%TYPE;
   dr 			loans.discount_rate%TYPE;
   oa 			loans.original_amount%TYPE;
   proft		loans.profit%TYPE;
   lid			loans.id%TYPE;
   trm			loans.term%TYPE;
   sql_stmt    		VARCHAR2(200);

BEGIN
-- Start a transaction;
   set TRANSACTION READ WRITE;

-- decrement the Term correctly
   FOR loan_rec IN c0 LOOP
      update loans set term = loan_rec.term - 1 where CURRENT OF c0;
   END LOOP;

-- for records that have a value in pric_remain and is of type fm.update prin_remain. and update term_remaining
   FOR loan_rec IN c1 LOOP
      update loans set principal_remaining =  round(loan_rec.principal_remaining - (loan_rec.monthly_payment - (loan_rec.principal_remaining * ((loan_rec.interest_rate / 100 )/ 12))), 2) where CURRENT OF c1;
   END LOOP;

-- for records that have pric_remain is null and is of type fm set pric_remain = original_amnt
   FOR loan_rec IN c2 LOOP
      update loans set principal_remaining =  loan_rec.original_amount where CURRENT OF c2;
   END LOOP;

--  For all borrowers. Calculate that borrowers risk.
---- 50 - (number of good loans) + (20 * each late loan) + (30 * each defaulted loan)
---- If a borrower has any loans is in late standing and the formula generates a borrower's risk factor below 65, then the 
------ borrower's risk factor is automatically increased to 65. Likewise,
---- If a borrower has any loans is in default standing and the formula generates a borrower?s risk factor below 90, 
------ then the borrower?s risk factor is automatically increased to 90.

   FOR borr_rec IN c3 LOOP
      good_loans 	:= 0;
      late_loans 	:= 0;
      default_loans 	:= 0;

      FOR num_rec IN c4(borr_rec.id) LOOP
	num_temp := num_rec.status;
	if num_temp = 0 THEN
	    good_loans := num_rec.num;
	  elsif num_temp = 1 THEN
 	       late_loans := num_rec.num;
	    elsif num_temp = 2 THEN
		 default_loans := num_rec.num;
        END if;
      END LOOP;
      calc_risk := 50 - (good_loans) + (20 * late_loans) + (30 * default_loans ); 
      if late_loans > 0 THEN
         if calc_risk < 65 THEN
            calc_risk := 65;
         END IF;
      END IF;
      if default_loans > 0 THEN
         if calc_risk < 90 THEN
            calc_risk := 90;
         END IF;
      END IF;
      update borrowers set risk = calc_risk where CURRENT OF c3;
   END LOOP;

-- For each Loan that we own calculate loan risk 
---- for all fixed rate loans that we own
   FOR loan_rec IN c5 LOOP

      select avg(risk) into n_risk from borrowers, borrowers_have_loans where id = borrower_id and loan_id = loan_rec.id;

      if n_risk < 1 then
         n_risk := 1;
      END IF;
      if n_risk > 100 then
         n_risk := 100;
      END IF;
      update loans set risk = n_risk where CURRENT OF c5;
   END LOOP;


   FOR loan_rec IN c7 LOOP
----for  all arm loans that we own
----select avg(risk) into n_risk from borrowers, borrowers_have_loans where id = borrower_id and loan_id = loan_rec.id;

select avg(risk) into n_risk from borrowers, borrowers_have_loans where id = borrower_id and loan_id = loan_rec.id;

      years_left := loan_rec.term / 12;
      n_risk := n_risk + (0.39 * years_left);
      if n_risk < 1 then
         n_risk := 1;
      END IF;
      if n_risk > 100 then
         n_risk := 100;
      END IF;
      update loans set risk = n_risk where CURRENT OF c7;
   END LOOP;

-- For each Loan that we own calculate discount_rate
---- Discount Rate = PR + (I * (0.2 + (.005 * (101-R))))
   FOR loan_rec IN c8 loop
      update loans set discount_rate = round((loan_rec.principal_remaining + (((loan_rec.monthly_payment * loan_rec.term) - loan_rec.principal_remaining) * (0.2 + (.005 * (101 - loan_rec.risk))))), 2) where CURRENT OF c8;
   END LOOP;


-- For each Loan that we own calculate profit
---- profit = (principal_remaining + interest) - discount_rate
   FOR loan_rec IN c9 loop
      update loans set profit = ROUND(((loan_rec.monthly_payment * loan_rec.term) - loan_rec.discount_rate), 2) where CURRENT OF c9;
   END LOOP;

-- delete loans that we never sold -- Maybe this should be changed to mark them as sold in some default bundle
   delete from loans where term = 0;
-- delete loans that we do not own
   delete from loans where purchased = 0;
-- delete borrowers that do not have loans
   delete from  borrowers where id not in (select UNIQUE borrower_id from borrowers_have_loans);
-- Commit the transaction
   COMMIT;
END lrrollforward;
/

-- Grant permisions to users to 
   grant execute on lrrollforward to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;




