-------------------------------
CREATE TABLE lenders (
id		number(10) NOT NULL,
name 		varchar(64) NOT NULL,
phone 	        varchar(14) DEFAULT NULL,
contact 	varchar(64) DEFAULT NULL,
CONSTRAINT lendersPK PRIMARY KEY(id)
);

-------------------------------
CREATE TABLE loans (
id  		number(10) NOT NULL,	-- Unique Identifyer VARIFY TYPE WITH NEW LOAN REPORT
lender_id 	number(10) NOT NULL,	-- Identifyer for lender of loan   
type 		number(1) NOT NULL,	-- 1 = regular, 0 = jumbo
status 		number(1) NOT NULL, 	-- (good, late, default) = (0, 1, 2)
candidate 	number(10) DEFAULT NULL,-- is this loan being considered for a bundle (holds analyst's ID if true otherwise null)
bundle_id 	number(10) DEFAULT NULL,-- ounce bundle is finalized, this field holds the Bundle_id (this field is neccessary to do the logging and later removal)
property_id 	number(10) NOT NULL,    -- The property this loan is associated with VARIFY TYPE WITH LOAN REPORT
original_amount number(10) NOT NULL,
principal_remaining 
		number(10,2) NOT NULL,
interest_rate_type
		number(1) NOT NULL, 	-- 0 = fixed Rate, 1 = variable Rate
discount_rate 	number(10,3) DEFAULT NULL,
interest_rate 	number(10,3) NOT NULL,
term 		number(3) NOT NULL,
settle_month    number(2) NOT NULL,
settle_day      number(2) NOT NULL,
settle_year     number(4) NOT NULL,
risk 		number(3) DEFAULT NULL,
profit		number(10,2) DEFAULT NULL,	-- expected Profit for an investor 
purchased	number(1) NOT NULL,	-- Does the FMCO own this loan 1=y, 0=n
monthly_payment	number(10,2) DEFAULT NULL,		
--interest	number(10,2) DEFAULT NULL,	-- Total interest payed over the fife of the loan
CONSTRAINT loanPK PRIMARY KEY(id),
CONSTRAINT loanLenderFK Foreign Key(lender_id) references lenders(id)
);

-------------------------------
CREATE TABLE borrowers (
id		number(10) NOT NULL,  		--Unique Identifyer
-- REMOVED FROM SPECS standing 	number(1) NOT NULL,  --0 = good, 1 = late, 2 =  default
name 		varchar(64) NOT NULL,
risk		number(3) DEFAULT 50,
CONSTRAINT borrowersPK PRIMARY KEY(id)
);

-------------------------------
CREATE TABLE borrowers_have_loans (	-- This table captures the one to many relationship 
				  		-- between borrowers and loans
borrower_id	number(10) NOT NULL,
loan_id 	number(10) NOT NULL,
CONSTRAINT borroHLbFK FOREIGN KEY(borrower_id) references borrowers(id),
CONSTRAINT borroHLloanFK FOREIGN KEY (loan_id) references loans(id) ON DELETE CASCADE 
);
-------------------------------
create sequence bundle_seq;
-------------------------------
CREATE TABLE bundles (  -- ? See Requirments Doc 5.3 #28
id 		number(10) NOT NULL,
date_sold 	varchar(40) NOT NULL,
investor	varchar(40) NOT NULL,
cost 		number(10,2) NOT NULL,
risk 		number(10) NOT NULL,
profit 	number(10,2) NOT NULL,
CONSTRAINT bundlePK PRIMARY KEY(id)
);
-- when INSERTING into this table the id value must be bundle_seq.nextval
-------------------------------
CREATE TABLE lr_system_global ( -- Single tuple table for system variables.
id		number(1) DEFAULT 1 NOT NULL, -- Should only contain 1
prevent_login 	number(1) DEFAULT 0 NOT NULL, -- 0 = false, 1 = true, used during Admin Functions and logins of course
optimize_running number(10) DEFAULT 0 NOT NULL -- 0 = false, 1 = true, used during Optimize function
);
-------------------------------
insert into lr_system_global(id) values (1);
-------------------------------
CREATE TABLE lr_system_loggin_id ( -- Sytem table for storing active loggin id.
lid 		number(10) NOT NULL,
CONSTRAINT system_log_PK PRIMARY KEY(lid)
);
-------------------------------

grant all on lenders to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;
grant all on loans to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472,  pats, cs536002;
grant all on borrowers to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;
grant all on borrowers_have_loans to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;
grant all on bundles to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;
grant all on lr_system_global to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;
grant all on lr_system_loggin_id to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;
grant select on bundle_seq to jpre4701, tric0489, dgus7193, cmer7116, jkur9319, skur0007, mneu1641, pdal4355, mazh1499, mbru9512, nkot9549, psch2107, mtan9472, pats, cs536002;

